<template>
  <form @submit.prevent="submitForm" class="formStyling">
    <div class="form-control" :class="{ invalid: !topic.isValid }">
      <label for="topic">Czego dotyczy zgłoszenie</label>
      <input
        type="text"
        id="topic"
        v-model.trim="topic.val"
        @blur="clearValidity('topic')"
      />
      <p v-if="!topic.isValid">Uzupełnij temat zgłoszenia.</p>
    </div>
    <div class="form-control" :class="{ invalid: !comment.isValid }">
      <label for="comment">Komentarz</label>
      <textarea
        id="comment"
        rows="2"
        v-model.trim="comment.val"
        @blur="clearValidity('comment')"
      ></textarea>
      <p v-if="!comment.isValid">Uzupełnij komentarz.</p>
    </div>
    <div class="form-control" :class="{ invalid: !image.isValid }">
      <label for="image">Zdjęcie</label>
      <input
        type="file"
        id="file"
        accept=".jpg, .jpeg, .png"
        @change="addFile"
        @blur="clearValidity('image')"
      />
      <p v-if="!image.isValid">Wybierz zdjęcie.</p>
    </div>
    <div class="form-control">
      <label for="unit">Jednostka organizacyjna (opcjonalne)</label>
      <select id="unit" name="unit" v-model="unit">
        <option v-for="unit in units" :key="unit['id']" :value="unit['id']">
          {{ unit["title"] }}
        </option>
      </select>
    </div>
    <div class="form-control">
      <label for="email">E-mail (opcjonalne)</label>
      <input type="email" id="email" v-model.trim="email" />
    </div>
    <div class="form-control">
      <label for="phone">Telefon (opcjonalne)</label>
      <input type="tel" id="phone" v-model.trim="phone" />
    </div>
    <div
      v-if="showEmailPermission || showPhonePermission"
      class="form-control"
      :class="{ invalid: !permissions.isValid }"
    >
      <div v-if="showEmailPermission">
        <input
          type="checkbox"
          id="emailPermission"
          value="email"
          v-model.trim="permissions.val"
          @blur="clearValidity('permissions')"
        />
        <label for="emailPermission"
          >Zgoda na wykorzystanie adresu e-mail do kontaktu.</label
        >
      </div>
      <div v-if="showPhonePermission">
        <input
          type="checkbox"
          id="phonePermission"
          value="phone"
          v-model.trim="permissions.val"
          @blur="clearValidity('permissions')"
        />
        <label for="phonePermission"
          >Zgoda na wykorzystanie numeru telefonu do kontaktu.</label
        >
      </div>
      <p v-if="!permissions.isValid">{{ showPermissionsError }}</p>
    </div>
    <div class="button">
      <base-button>Wyślij formularz</base-button>
    </div>
  </form>
</template>

<script setup>
import { ref, computed, defineEmits, defineProps } from "vue";
// import { ref, computed, defineProps } from "vue";

const emit = defineEmits(["save-data"]);
defineProps(["units"]);

const topic = ref({
  val: "",
  isValid: true,
});
const comment = ref({
  val: "",
  isValid: true,
});
const permissions = ref({
  val: [],
  isValid: true,
});
const image = ref({
  val: "",
  isValid: true,
});
const unit = ref("");
const email = ref("");
const phone = ref("");

const formIsValid = ref(true);

function clearValidity(input) {
  this[input].isValid = true;
}

function addFile(e) {
  image.value.val = e.target.files[0];
  createBase64Image(image.value.val);
}

function createBase64Image(fileObject) {
  const reader = new FileReader();

  reader.onload = (e) => {
    image.value.val = e.target.result;
  };
  reader.readAsDataURL(fileObject);
}

function validateForm() {
  formIsValid.value = true;
  if (topic.value.val === "") {
    topic.value.isValid = false;
    formIsValid.value = false;
  }
  if (comment.value.val === "") {
    comment.value.isValid = false;
    formIsValid.value = false;
  }
  if (image.value.val === "") {
    image.value.isValid = false;
    formIsValid.value = false;
  }
  if (
    (email.value !== "" && permissions.value.val.indexOf("email") === -1) ||
    (phone.value !== "" && permissions.value.val.indexOf("phone") === -1)
  ) {
    permissions.value.isValid = false;
    formIsValid.value = false;
  }
}

function submitForm() {
  validateForm();

  if (!formIsValid.value) {
    return;
  }

  // const formData = {
  //   topic: topic.value.val,
  //   comment: comment.value.val,
  //   unit: unit.value,
  //   email: email.value,
  //   phone: phone.value,
  //   emailPermission: permissions.value.val.indexOf("email") !== -1,
  //   phonePermission: permissions.value.val.indexOf("phone") !== -1,
  // };
  //
  // emit("save-data", formData);
  emit("save-data", image.value.val);
}

const showEmailPermission = computed(function () {
  return email.value !== "";
});
const showPhonePermission = computed(function () {
  return phone.value !== "";
});
const showPermissionsError = computed(function () {
  return showEmailPermission.value && showPhonePermission.value
    ? "Zatwierdź zgody."
    : "Zatwierdź zgodę.";
});
</script>
